package asynctaskexample.mrbool.com.asynctaskmrbool;

import android.app.ProgressDialog;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;

import java.io.IOException;

public class MainActivity extends AppCompatActivity {

    private ImageView image;
    private Button btnDownload;
    private EditText edtAddress;
    private ProgressDialog load;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        image = (ImageView) findViewById(R.id.imageView);
        btnDownload = (Button) findViewById(R.id.button);
        edtAddress = (EditText) findViewById(R.id.editText);
        Log.i("AsyncTask", "Screen elements created and Thread attributes: " + Thread.currentThread().getName());
        btnDownload.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.i("AsyncTask", "Thread Clicked Button: " + Thread.currentThread().getName());
                callAsyncTask(edtAddress.getText().toString());
            }
        });
    }

    private void callAsyncTask(String address) {
        TaskDownload download = new TaskDownload();
        Log.i("AsyncTask", "AsyncTask being called by Thread: " + Thread.currentThread().getName());
        download.execute(address);
    }

    private class TaskDownload extends AsyncTask<String, Void, Bitmap> {
        @Override
        protected void onPreExecute() {
            Log.i("AsyncTask", "Showing ProgressDialog on the screen Thread: " + Thread.currentThread().getName());
            load = ProgressDialog.show(MainActivity.this, "Please wait ...", "Downloading image ...");
        }

        @Override
        protected Bitmap doInBackground(String... params) {
            Bitmap bitmapImage = null;
            try {
                Log.i("AsyncTask", "Downloading image on Thread: " + Thread.currentThread().getName());
                bitmapImage = Auxiliar.downloadImage(params[0]);
            } catch (IOException e) {
                Log.i("AsyncTask", e.getMessage());
            }
            return bitmapImage;
        }

        @Override
        protected void onPostExecute(Bitmap bitmap) {
            if (bitmap != null) {
                image.setImageBitmap(bitmap);
                Log.i("AsyncTask", "Showing Bitmap Thread: " + Thread.currentThread().getName());
            } else {
                Log.i("AsyncTask", "Error at btnDownload the image " + Thread.currentThread().getName());
            }
            Log.i("AsyncTask", "Removing ProgressDialog from screen in Thread: " + Thread.currentThread().getName());
            load.dismiss();
        }
    }

}
